/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package synthesisclient;

import java.io.*;
import java.net.*;
import javax.sound.sampled.*;

/**
 *
 * @author Trond
 */
public class SynthesisClient {
    
    private Socket requestSocket = null;
    private byte[] buffer;
    private String outputFilePath;
    
    //Paths to Codecs
    String mp3 = "lame";
    String ogg = "oggenc";
    String speex = "speexenc";

    public void setupSocket()
    {
        try
        {
            // Connect to server, with specified timeout
            InetAddress addr = InetAddress.getByName("orwell.idi.ntnu.no");
            int port = 8888;
            SocketAddress sockaddr = new InetSocketAddress(addr, port);
            requestSocket = new Socket();
            requestSocket.connect(sockaddr, 10000);
        } catch (SocketException e)
        {
            System.out.println("SOCKET FAIL");
            e.printStackTrace();
        } catch (IOException e)
        {
            System.out.println("IO FAIL");
            e.printStackTrace();
        }
    }

    public String run(String text, String path)
    {
        try
        {
            setupSocket();
            //requestSocket = new Socket(addr, 8888);//("129.241.102.132", 8888);
            System.out.println("Connected");
            // Send a test query
            BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(requestSocket.getOutputStream(), "ISO8859-1"));
            bufferedWriter.write(text);
            bufferedWriter.flush();

            // Receive input
            InputStream is = requestSocket.getInputStream();

            //Read from inputstream
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            int nRead;
            byte[] data = new byte[16384];
            while ((nRead = is.read(data, 0, data.length)) != -1) {
                baos.write(data, 0, nRead);
            }
            baos.flush();           
            buffer = baos.toByteArray();
            is.close();
            bufferedWriter.close();
                
            //-- A-law --
            System.out.print("Creating Wave header for A-law file...");             
            FileOutputStream fos = new FileOutputStream(path);//"/home/trondboe/audio/nora_alaw.wav");           
            //Header
            short numOfChannels_alaw = 1;
            short bitsPerSample_alaw = 8;
            WaveHeader alawHeader = new WaveHeader(WaveHeader.FORMAT_ALAW, numOfChannels_alaw, 8000, bitsPerSample_alaw, buffer.length);
            alawHeader.write(fos);       
            fos.write(buffer); //Data
            fos.close();
            System.out.println("Done"); 
            
            //-- Uncompressed --
            System.out.print("Creating uncompressed file..."); 
            FileOutputStream fos2 = new FileOutputStream("/home/trondboe/audio/nora_uncompressed.wav");           
            byte[] unCompBuffer = new byte[buffer.length*2];           
            //Header
            short numOfChannels = 1;
            short bitsPerSample = 16;
            WaveHeader uncompressedHeader = new WaveHeader(WaveHeader.FORMAT_PCM, numOfChannels, 8000, bitsPerSample, unCompBuffer.length);            
            uncompressedHeader.write(fos2); 
            
            process(buffer, 0, buffer.length, unCompBuffer);            
            fos2.write(unCompBuffer); //Data
            fos2.close();
            System.out.println("Done.");
            
            /*Compress sound file 
            int mode = 1; // wide band
            int sampleRate = 8000;
            int channels = 1;
            int quality = 10; // high quality
            
            SpeexEncoder speexEncoder = new SpeexEncoder();
            speexEncoder.init(mode, quality, sampleRate, channels);
            int numSamples = speexEncoder.getFrameSize();
            System.out.println("numSamples: " + numSamples);

            System.out.println(unCompBuffer.length);
            speexEncoder.processData(unCompBuffer, 0, unCompBuffer.length);
            System.out.println(unCompBuffer.length);*/
            
            //Oggvorbis encode. Only works for 2ch 44100rate
            //MyVorbisEncoder ve = new MyVorbisEncoder();
            //ve.encode("c:\\nora_uncompressed.wav","c:\\nora_vorbis.ogg")
            
            /*Speex
            System.out.print("Compressing with Speex...");
            //Quality between 1 and 9 (Highest quality).
            compressSpeex("c:\\nora_uncompressed.wav", "c:\\nora_low.spx", 1);
            compressSpeex("c:\\nora_uncompressed.wav", "c:\\nora_med.spx", 5);
            compressSpeex("c:\\nora_uncompressed.wav", "c:\\nora_high.spx", 9);       
            System.out.println("..Done");*/
            
            /*Ogg Vorbis Compression - using oggenc
            //Quality between 2 and 10 (Highest quality).
            System.out.print("Compressing with Ogg..."); 
            compressOgg("c:\\nora_uncompressed.wav", "c:\\nora_low.ogg", 2);
            compressOgg("c:\\nora_uncompressed.wav", "c:\\nora_med.ogg", 6);
            compressOgg("c:\\nora_uncompressed.wav", "c:\\nora_high.ogg", 10);
            //Find speech medium same size
            ExecProgram.exec(ogg+" -b 14 c:\\nora_uncompressed.wav -o c:\\nora_findspx.ogg", false); //ULow Bitrate Quality
            System.out.println("..Done");*/
            
            //MP3 Compression - using Lame
            //String bitrate = " -b 128 ";
            //String vbrQ = " -V 0 "; //VBR quality, ranging from 0 (best quality) to 9 (smaller files).
            System.out.print("Compressing with MP3..."); 
            //compressMp3("/home/trondboe/audio/nora_uncompressed.wav", "/home/trondboe/audio/nora_low.mp3", 9);
            compressMp3("/home/trondboe/audio/nora_uncompressed.wav", "/home/trondboe/audio/nora_med.mp3", 9);
            //compressMp3("/home/trondboe/audio/nora_uncompressed.wav", "/home/trondboe/audio/nora_high.mp3", 0);
            outputFilePath = "/home/trondboe/audio/nora_med.mp3";
            System.out.println("Done");
            /*ExecProgram.exec(mp3+" "+hq+vbrQ+"c:\\nora_uncompressed.wav c:\\nora_vbr_high.mp3"); //High VBR Quality
            vbrQ = " -V 9 ";
            ExecProgram.exec(mp3+" "+hq+vbrQ+"c:\\nora_uncompressed.wav c:\\nora_vbr_low.mp3"); //Low VBR Quality
            String bitrate = " -b 128 ";
            ExecProgram.exec(mp3+" "+bitrate+"c:\\nora_uncompressed.wav c:\\nora_bitrate_high.mp3"); //High bitrate Quality
            bitrate = " -b 16 ";*/
            
            /*Find speech medium same size
            ExecProgram.exec(mp3+" -b 14 c:\\nora_uncompressed.wav c:\\nora_findspx.mp3", false); 
            System.out.println("..Done");*/
            
            /*Compress by Zip
            System.out.print("Zipping...");
            Zip.compress("c:\\nora_low.ogg");
            Zip.compress("c:\\nora_low.mp3");
            System.out.println("Done");*/
            
            //Extract Zip
            //System.out.print("Unzipping...");
            //Zip.extract("c:\\nora_alaw.zip");
            //System.out.println("Done");       
            
            //Return regular alaw
            //outputFilePath = path;
            
            return outputFilePath;
        } catch (Exception e)
        {
            e.printStackTrace();
            System.out.println("Error: "+e);
            return null;
            //  System.exit(1);
        } finally{
            try{
                if(requestSocket != null){
                    requestSocket.close();
                    System.out.println("Socket closed: " + requestSocket.isClosed());
                }
            } catch (Exception e)
            {
                System.out.println("Exception closing socket in SocketTest::run()");
            }
            
        }
    }
    
    public boolean compressSpeex(String inputFile, String outputFile, int quality){
        if(quality < 1 || quality > 9) return false;
        ExecProgram.exec(speex+" --quality "+quality+" "+inputFile+" "+outputFile, false);
        return true;
    }
    
    public boolean compressOgg(String inputFile, String outputFile, int quality){
        if(quality < 2 || quality > 10) return false;
        ExecProgram.exec(ogg+" -q "+quality+" "+inputFile+" -o "+outputFile, false); 
        return true;
    }
    
    public boolean compressMp3(String inputFile, String outputFile, int quality){
        if(quality < 0 || quality > 9) return false;
       // System.out.println(mp3+" -V "+quality+" "+inputFile+" "+outputFile);
        ExecProgram.exec(mp3+" -V "+quality+" "+inputFile+" "+outputFile, true);
        return true;
    }
    
    /** decompress table constants */
    private static short aLawDecompressTable[] = new short[]{
        -5504, -5248, -6016, -5760, -4480, -4224, -4992, -4736,
        -7552, -7296, -8064, -7808, -6528, -6272, -7040, -6784,
        -2752, -2624, -3008, -2880, -2240, -2112, -2496, -2368,
        -3776, -3648, -4032, -3904, -3264, -3136, -3520, -3392,
        -22016, -20992, -24064, -23040, -17920, -16896, -19968, -18944,
        -30208, -29184, -32256, -31232, -26112, -25088, -28160, -27136,
        -11008, -10496, -12032, -11520, -8960, -8448, -9984, -9472,
        -15104, -14592, -16128, -15616, -13056, -12544, -14080, -13568,
        -344, -328, -376, -360, -280, -264, -312, -296,
        -472, -456, -504, -488, -408, -392, -440, -424,
        -88, -72, -120, -104, -24, -8, -56, -40,
        -216, -200, -248, -232, -152, -136, -184, -168,
        -1376, -1312, -1504, -1440, -1120, -1056, -1248, -1184,
        -1888, -1824, -2016, -1952, -1632, -1568, -1760, -1696,
        -688, -656, -752, -720, -560, -528, -624, -592,
        -944, -912, -1008, -976, -816, -784, -880, -848,
        5504, 5248, 6016, 5760, 4480, 4224, 4992, 4736,
        7552, 7296, 8064, 7808, 6528, 6272, 7040, 6784,
        2752, 2624, 3008, 2880, 2240, 2112, 2496, 2368,
        3776, 3648, 4032, 3904, 3264, 3136, 3520, 3392,
        22016, 20992, 24064, 23040, 17920, 16896, 19968, 18944,
        30208, 29184, 32256, 31232, 26112, 25088, 28160, 27136,
        11008, 10496, 12032, 11520, 8960, 8448, 9984, 9472,
        15104, 14592, 16128, 15616, 13056, 12544, 14080, 13568,
        344, 328, 376, 360, 280, 264, 312, 296,
        472, 456, 504, 488, 408, 392, 440, 424,
        88, 72, 120, 104, 24, 8, 56, 40,
        216, 200, 248, 232, 152, 136, 184, 168,
        1376, 1312, 1504, 1440, 1120, 1056, 1248, 1184,
        1888, 1824, 2016, 1952, 1632, 1568, 1760, 1696,
        688, 656, 752, 720, 560, 528, 624, 592,
        944, 912, 1008, 976, 816, 784, 880, 848
    };
    /**
     * Perform decompression using A-law.
     * 
     * @param mediaType the input compressed media
     * @return the output decompressed media.
     */
    private int process(byte[] src, int offset, int len, byte[] res) {
        int j = 0;
        for (int i = 0; i < len; i++) {
            short s = aLawDecompressTable[src[i + offset] & 0xff];
            res[j++] = (byte) s;
            res[j++] = (byte) (s >> 8);
        }
        return 2 * len;
    }
    

    public static void main(String[] args) {
        // TODO code application logic here
        
      //  SynthesisClient sc = new SynthesisClient();
     //   sc.run("Hei og hå! BLA BLAB ALABALA BALA Hurramegrundt. No ska eg til Dragvoll!");     
    }
}
